package com.jd.dynamic.apis

import android.content.Context
import androidx.annotation.Keep
import androidx.annotation.NonNull
import com.jd.dynamic.base.IFunctionFactory

/**
 * @author: xuepanjie1
 * @date:2022/3/18
 * @description: 获取 container 的 config。
 * @param 例如：context, function factory、is auto dark、templateId
 */
@Keep
class DYContainerConfig(
    @NonNull val context: Context,
    @NonNull val module: String,
    @NonNull val templateId: String,
    val factory: IFunctionFactory? = null
) {
    private var isAutoListen: Boolean = true
    private var pkgName: String? = null
    private var useAsyncItem:Boolean = false
    private var skeletonHeight:Int = 120
    private var useSkeleton:Boolean = false

    private var useTagViewOptimize:Boolean = false
    private var useCacheView: Boolean = false
    private var containerWidth:Int=0 // 动态化容器预设宽高
    private var containerHeight:Int=0 // 动态化容器预设宽高
    fun setUseCacheView(useCacheView:Boolean){
        this.useCacheView = useCacheView;
    }


    private var isUseCustomBackup = false

    fun setPackageName(name: String) {
        this.pkgName = name
    }

    fun getPackageName() : String? {
        return pkgName
    }
    fun setUseAsyncItem(useAsyncItem:Boolean){
        this.useAsyncItem = useAsyncItem
    }
    fun isUseAsyncItem():Boolean{
        return useAsyncItem
    }
    fun setSkeletonSetting(useSkeleton:Boolean,skeletonHeight:Int){
        this.useSkeleton = useSkeleton
        this.skeletonHeight = skeletonHeight
    }
    fun isUseSkeleton():Boolean{
        return useSkeleton
    }
    fun getSkeletonHeight():Int{
        return skeletonHeight
    }
    fun isUseCacheView():Boolean{
        return useCacheView
    }
    /**
     * 是否自动监听暗黑变化，默认true
     */
    fun shouldAutoListenDarkStatus(isAutoListen:Boolean){
        this.isAutoListen = isAutoListen;
    }
    fun isAutoListenDarkStatus():Boolean{
        return this.isAutoListen
    }

    /**
     * 是否使用TagView优化方案
     */
    fun isUseTagViewOptimize():Boolean{
        return useTagViewOptimize
    }
    /**
     * 设置是否使用TagView优化方案
     */
    fun setUseTagViewOptimize(useTagViewOptimize:Boolean){
        this.useTagViewOptimize = useTagViewOptimize
    }
    

    fun setUseCustomBackup(useBackup: Boolean) {
        this.isUseCustomBackup = useBackup
    }

    fun getUseCustomBackup() : Boolean {
        return isUseCustomBackup
    }

    fun setContainerWidth(containerWidth: Int){
        this.containerWidth = containerWidth
    }

    fun getContainerWidth():Int{
        return containerWidth
    }

    fun setContainerHeight(containerHeight: Int){
        this.containerHeight = containerHeight
    }

    fun getContainerHeight():Int{
        return containerHeight
    }

}