package com.jd.dynamic.apis

import androidx.annotation.Keep
import androidx.annotation.NonNull
import com.jd.dynamic.base.IFunctionFactory

/**
 * @author: xuepanjie1
 * @date:2022/3/18
 * @description:
 */
@Keep
interface IDynamicDriver {
    /**
     * @param module module name
     * @param scene the scene of module
     * */
    fun prepare(@NonNull module: String, @NonNull scene: String)

    /**
     * @param config create container configs
     * */
    fun createContainer(@NonNull config: DYContainerConfig): DynamicContainer?

    fun createContainer(
        @NonNull config: DYContainerConfig,
        @NonNull listener: IDYContainerListener
    ): DynamicContainer?

    fun getTemplateStatus(@NonNull module: String, @NonNull templateId: String): DYTemplateStatus

    fun registerCustomFunctionFactory(@NonNull sysCode: String,
                                      @NonNull biz: String,
                                      @NonNull factory:IFunctionFactory): Boolean

    fun getFunctionFactory(@NonNull sysCode: String,
                           @NonNull biz: String) : IFunctionFactory?
}