package com.jd.dynamic.engine.base.invoker

import com.jd.dynamic.base.DynamicTemplateEngine
import com.jd.dynamic.engine.JSCDynContext
import com.jd.dynamic.lib.dynamic.parser.ViewProcessor
import com.jd.dynamic.lib.utils.CommonUtil
import com.jd.dynamic.lib.utils.FunctionDispatcher

/**
 * @author: xuepanjie1
 * @date:2023/3/15
 * @description:
 */

class UserEventsInvoker(private val engine: DynamicTemplateEngine?,
                        private val jscDynContext: JSCDynContext?) : Invoker {
    override fun getName(): String {
        return "events"
    }

    override fun onInvoke(
        jscDynContext: JSCDynContext?,
        methodName: String?,
        vararg params: Any?
    ): Any {
        return if (params.size == 1) {
            if (params[0] is Double || params[0] is String) {
                var targetViewId: Int? = null
                targetViewId = if (params[0] is String) {
                    ViewProcessor.getViewIdByLayoutId(engine, params[0] as String)
                } else {
                    (params[0] as Double).toInt()
                }
                FunctionDispatcher.dispatcherFunction(methodName, null, engine,
                    CommonUtil.getPendingView(engine, targetViewId, jscDynContext?.targetView))
            } else {
                FunctionDispatcher.dispatcherFunction(methodName, params[0], engine, jscDynContext?.targetView)
            }
        } else {
            FunctionDispatcher.dispatcherFunction(methodName, jscDynContext?.targetView, engine, jscDynContext?.targetView)
        }
    }
}