package com.jd.dynamic.lib.expv2

import androidx.collection.LruCache
import com.jd.dynamic.DYConstants
import com.jd.dynamic.lib.expv2.nodes.XPNode
import java.util.concurrent.atomic.AtomicBoolean

/**
 * @author: xuepanjie1
 * @date:2022/10/20
 * @description:
 */

object ExpCachePool {
    private val cacheInit = AtomicBoolean(false)
    private var cachePool: LruCache<String, XPNode>? = null
    private val cacheHashMap = HashMap<String, XPNode>()

    fun start(size: Int) {
        if (cacheInit.get()) {
            return
        }
        cachePool = LruCache(size)
        cacheInit.set(true)
    }

    fun setCacheNode(exp: String, node: XPNode) {
//        cachePool?.put(exp, node)
        cacheHashMap[exp] = node
    }

    fun getCacheNode(exp: String) : XPNode? {
        val startGet = System.nanoTime()
        val cacheNode = cacheHashMap?.get(exp)
        cacheNode?.releaseImmResult()
        DYConstants.DYLog(" release use time is : ${System.nanoTime() - startGet}")
        return cacheNode
    }

    fun clearCache() {
        cacheInit.set(false)
//        cachePool?.evictAll()
        cacheHashMap.clear()
    }
}