package com.jd.dynamic.lib.expv2

import android.text.TextUtils
import com.jd.dynamic.DYConstants
import java.math.BigDecimal

/**
 * @author: xuepanjie1
 * @date:2021/12/27
 * @description:
 */

const val EMPTY_STR = ""
const val SPACE_STR = " "
const val SYMBOL_COLON = ":"

const val SYMBOL_BIG_BRACKET_L = '{'
const val DOUBLE_SYMBOL_PH = '#'
const val DOUBLE_SYMBOL_PH_R = '`'
const val SYMBOL_BIG_BRACKET_R = '}'
const val SYMBOL_MIDDLE_BRACKET_L = '['
const val SYMBOL_MIDDLE_BRACKET_R = ']'
const val SYMBOL_SMALL_BRACKET_L = '('
const val SYMBOL_SMALL_BRACKET_R = ')'

const val SYMBOL_DOLLAR = '$'

// 符号表达式 $dark() 等
// 取值表达式前缀 、三木表达式前缀
const val SYMBOL_PATH = "\${"

// 条件表达式前缀
const val SYMBOL_CONDITION = "@{"

// event function
const val SYMBOL_EVENT_FUNC = "fun{"

// 中间值标记
const val SYMBOL_TAG_INTERMEDIATE_VALUE = "P_H"

const val INVALID_POS = -1

fun Any?.notIllegal(): Boolean {
    return null != this && this.toString() != DYConstants.DY_NULL_STR
            && this.toString() != DYConstants.DY_EMPTY_STR
}

fun String.needRemovePH(): Boolean {
    if (length < 3) {
        return false
    }
    val right = this.indexOf(DOUBLE_SYMBOL_PH)
    return right >= DYConstants.DY_INT_ZERO &&
            this.lastIndexOf(DOUBLE_SYMBOL_PH_R) > right + 1
}

const val FLAG_NOT_B_M: Byte = 0
const val FLAG_B: Byte = 1
const val FLAG_M: Byte = 2

fun String.containBOrM(): Byte {
    if (this.startsWith(SYMBOL_BIG_BRACKET_L)) {
        return FLAG_B
    }
    if (this.startsWith(SYMBOL_MIDDLE_BRACKET_L)) {
        return FLAG_M
    }
    return FLAG_NOT_B_M
}


fun str2BigDecimal(str: String) : BigDecimal {
    if (TextUtils.isEmpty(str)) {
        return BigDecimal(DYConstants.DY_INT_NEGATIVE_ONE)
    }

    return try {
        BigDecimal(str)
    } catch (e: Exception) {
        BigDecimal(DYConstants.DY_INT_NEGATIVE_ONE)
    }
}

