package com.jd.dynamic.lib.expv2

import android.view.View
import com.jd.dynamic.DYConstants
import com.jd.dynamic.base.DynamicTemplateEngine
import com.jd.dynamic.lib.expv2.nodes.IXPNodeFactory
import com.jd.dynamic.lib.expv2.nodes.XPNode
import com.jd.dynamic.lib.expv2.nodes.XPNodeFactory
import com.jd.dynamic.lib.expv2.evaluators.XPEvaluatorFactory

/**
 * @author: xuepanjie1
 * @date:2022/1/7
 * @description:
 */

class XPDriverV1 : XPBaseDriver() {
    private var engine: DynamicTemplateEngine? = null
    private var obj: Any? = null
    private var view: View? = null
    override fun attachObjs(engine: DynamicTemplateEngine?, obj: Any?, view: View?) {
        this.engine = engine
        this.obj = obj
        this.view = view
    }

    override fun getNodeFactory(): IXPNodeFactory {
        // 这里 new 出来耗时比较多。
        return XPNodeFactory(XPEvaluatorFactory(engine, obj, view))
    }

    override fun parse(exp: String): Any? {
        if (exp.startsWith(SYMBOL_EVENT_FUNC)) {
            return exp
        }
        val node = super.parse(exp)
        if (node is XPNode) {
            val result = node.parseResult()
            if (!result.notIllegal()) {
                return EMPTY_STR
            }
            return result
        }
        return EMPTY_STR
    }

    fun getRootNode(exp: String): XPNode? {
        val node = super.parse(exp)
        return if (node is XPNode) {
            node
        } else {
            null
        }
    }
}