package com.jd.dynamic.lib.expv2.evaluators

import android.view.View
import com.jd.dynamic.base.DynamicTemplateEngine
import com.jd.dynamic.lib.expv2.nodes.*

/**
 * @author: xuepanjie1
 * @date:2021/12/27
 * @description:
 */

class XPEvaluatorFactory(
    private val engine: DynamicTemplateEngine? = null,
    private val obj: Any? = null,
    private val view: View? = null
) : IXPEvaluatorFactory {
    /**
     * 返回对应 node 的 parser，这里直接把 node 传递进去
     * */
    override fun getParser(node: XPNode): XPEvaluator {
        return when (node) {
            is PathNode -> TakeValueEvaluator(engine, obj, view)
            is FunctionNode -> FunctionEvaluator(engine,obj,view)
            is BracketNode -> BracketEvaluator()
            is ConditionNode -> ConditionEvaluator(engine)
            is EventFuncNode -> EventFuncEvaluator(engine, obj, view)
            else -> TextEvaluator()
        }
    }
}