package com.jd.dynamic.lib.expv2.nodes

import android.view.View
import com.jd.dynamic.base.DynamicTemplateEngine
import com.jd.dynamic.lib.expv2.SYMBOL_BIG_BRACKET_L
import com.jd.dynamic.lib.expv2.SYMBOL_BIG_BRACKET_R
import com.jd.dynamic.lib.expv2.SYMBOL_SMALL_BRACKET_L
import com.jd.dynamic.lib.expv2.SYMBOL_SMALL_BRACKET_R

/**
 * @author: xuepanjie1
 * @date:2021/12/28
 * @description: 括号节点，这个用于内部使用
 */

class BracketNode(content: String) : XPRootNode(content) {
    override fun isMatch(tail: String): Boolean {
        this.tail = tail
        if (SYMBOL_BIG_BRACKET_L.toString() == head) {
            return tail == SYMBOL_BIG_BRACKET_R.toString()
        }
        if (SYMBOL_SMALL_BRACKET_L.toString() == head) {
            return tail == SYMBOL_SMALL_BRACKET_R.toString()
        }
        return false
    }

    override fun canBeRoot(): Boolean {
        return false
    }

    override fun fallthroughBoundResults(): Boolean {
        return true
    }

    override fun intermediateResult(): Any? {
        return parseContent()
    }

    override fun evalValue(obj: Any?, engine: DynamicTemplateEngine?, targetView: View?): Any? {
        return super.evalResultInner(obj, engine, targetView)
    }

}