package com.jd.dynamic.lib.expv2.nodes

import android.view.View
import com.jd.dynamic.base.DynamicTemplateEngine
import com.jd.dynamic.lib.expv2.EMPTY_STR
import com.jd.dynamic.lib.expv2.SYMBOL_BIG_BRACKET_R
import com.jd.dynamic.lib.expv2.evaluators.util.ResultContainer
import com.jd.dynamic.lib.expv2.needRemovePH
import com.jd.dynamic.lib.utils.FunctionDispatcher

/**
 * @author: xuepanjie1
 * @date:2021/12/31
 * @description: event fun{} 类型节点
 */

class EventFuncNode(head: String) : XPRootNode(head) {
    override fun isMatch(tail: String): Boolean {
        this.tail = tail
        return tail == SYMBOL_BIG_BRACKET_R.toString()
    }


    companion object {
        public const val SMALLEST_LENGTH = 5
    }

    override fun evalResultInner(
        obj: Any?,
        engine: DynamicTemplateEngine?,
        targetView: View?
    ): Any? {
        val content = super.evalResultInner(obj, engine, targetView)
        if (content is String) {
            val result = FunctionDispatcher.dispatcherFunction(
                getEventFuncId(content, this),
                obj, engine, targetView
            )
            return ResultContainer(result)
        }
        return content
    }

    private fun getEventFuncId(exp: String, node: XPNode): String {
        val length = exp.length
        if (length <= SMALLEST_LENGTH) {
            return EMPTY_STR
        }
        val event = exp.substring(4, length - 1)
        return if (event.needRemovePH()) {
            val origin = node.restore(event)
            if (origin is String) {
                origin
            } else {
                EMPTY_STR
            }
        } else {
            event
        }
    }
}