package com.jd.dynamic.lib.expv2.nodes

import android.view.View
import com.jd.dynamic.base.DynamicTemplateEngine

/**
 * @author: xuepanjie1
 * @date:2021/12/28
 * @description: 文本节点，主要保存内部的文本数据，不可作为父节点
 */

class TextNode(content: String) : XPNode(content) {
    override fun canBeRootNode(): Boolean {
        return false
    }

    override fun isMatch(tail: String): Boolean {
        this.tail = tail
        return true
    }

    override fun parseContent(): String? {
        return head
    }

    override fun intermediateResult(): Any? {
        return parseContent()
    }

    override fun evalValue(obj: Any?, engine: DynamicTemplateEngine?, targetView: View?): Any? {
        return parseContent()
    }

    override fun evalResultInner(
        obj: Any?,
        engine: DynamicTemplateEngine?,
        targetView: View?
    ): Any? {
        return parseContent()
    }
}