package com.jd.dynamic.lib.expv2.utils

import com.jd.dynamic.DYConstants

/**
 * @author: xuepanjie1
 * @date:2021/12/27
 * @description: 扫描工具类
 */

class XPStringScanner(private val origin: String) {
    private val originChars = origin.toCharArray()
    private val endLength = origin.length
    private var scanIndex = 0

    private fun isContainChar(flags: CharArray, target: Char) : Boolean {
        for (flag in flags) {
            if (flag == target) {
                return true
            }
        }
        return false
    }

    fun scanDataWithFlags(flags: CharArray): String? {
        if (scanIndex > endLength) {
            DYConstants.DYLog("scan index not valid ")
            return null
        }
        var index = scanIndex
        while (index < endLength) {
            val cc = originChars[index]
            if (isContainChar(flags, cc)) {
                val ttt = origin.substring(scanIndex, index+1)
                scanIndex = index + 1
                return ttt
            }
            index++
        }
        scanIndex = index + 1
        return null
    }

    fun reverseSearch(data: String, target: Char): Int {
        val chars = data.toCharArray()
        chars.reverse()
        chars.forEachIndexed { index, c ->
            if (c == target) {
                return chars.size - 1 - index
            }
        }
        return -1
    }

    fun canScan(): Boolean {
        return endLength > scanIndex
    }
}