package com.jd.dynamic.lib.report.impl

import com.jd.dynamic.base.DynamicSdk
import com.jd.dynamic.lib.ab.DYABConfigUtil
import com.jd.dynamic.lib.report.ReportManager
import com.jd.dynamic.lib.report.interfaces.IDYTask
import com.jd.dynamic.lib.report.interfaces.IDYWorker
import com.jd.dynamic.lib.report.interfaces.IReporter

/**
 * @author: xuepanjie1
 * @date:2022/12/22
 * @description:
 */

class CycleReportTask(private val reporter: IReporter,
                      private val worker: IDYWorker) : IDYTask {
    override fun execute() {
        val count = DYABConfigUtil.getInstance().reportCount
        val gap = DYABConfigUtil.getInstance().reportGap
        if (reporter is Reporter) {
            val config = reporter.getConfig()
            if (count != config.triggerCount || gap != config.triggerGap) {
                reporter.attachConfig(ReportManager.getInstance().createConfig(count, gap))
            }

            worker.postDelay(this, reporter.getConfig().triggerGap)
        }

        reporter.reportImmediate(DynamicSdk.getEngine().appType)
    }
}