package com.jd.dynamic.lib.report.impl

import android.os.Handler
import android.os.HandlerThread
import com.jd.dynamic.lib.report.interfaces.IDYTask
import com.jd.dynamic.lib.report.interfaces.IDYWorker


/**
 * @author: xuepanjie1
 * @date:2022/12/22
 * @description:
 */

class DefaultReportWorker : IDYWorker {
    private var worker: Handler
    private var workerThread: HandlerThread = HandlerThread("REPORT_WORKER")

    init {
        workerThread.start()
        worker = Handler(workerThread.looper)
    }

    override fun postTask(task: IDYTask) {
        worker.post { task.execute() }
    }

    override fun postDelay(task: IDYTask, delay: Long) {
        worker.postDelayed({ task.execute() }, delay)
    }
}