package com.jd.dynamic.lib.report.impl

import com.jd.dynamic.lib.ab.DYABConfigUtil
import com.jd.dynamic.lib.report.ReportManager
import com.jd.dynamic.lib.report.interfaces.IReportFactory
import com.jd.dynamic.lib.report.interfaces.IReporter

/**
 * @author: xuepanjie1
 * @date:2022/2/28
 * @description:
 */

class ReportFactoryImpl : IReportFactory {
    private val reporters: MutableMap<String, IReporter> = HashMap()

    private val lock : Any = Any()

    override fun createReporter(module: String): IReporter {
        synchronized(lock) {
            return if (reporters.containsKey(module)) {
                val reporter = reporters[module]!!
                reporter
            } else {
                val reporter = Reporter(module)
                reporters[module] = reporter
                val count = DYABConfigUtil.getInstance().reportCount
                val gap = DYABConfigUtil.getInstance().reportGap
                reporter.attachConfig(ReportManager.getInstance().createConfig(count, gap))
                reporter
            }
        }
    }
}