package com.jd.dynamic.lib.storage

import android.os.Handler
import android.os.HandlerThread
import java.lang.Exception

/**
 * @author: xuepanjie1
 * @date:2022/4/11
 * @description:
 */

class DYHandlerWorker(name: String) : DYStorageWorker(name) {
    private var worker: Handler

    init {
        val handlerThread = HandlerThread(name)
        handlerThread.start()
        worker = Handler(handlerThread.looper)
    }

    override fun post(task: IDYStorageTask) {
        worker.post(Task(task))
    }

    inner class Task(private val task: IDYStorageTask) : Runnable {
        override fun run() {
            try {
                task.execute()
            } catch (ignore: Exception) {
                ignore.printStackTrace()
            }
        }
    }
}