package com.jd.dynamic.lib.storage.cleaner

import com.jd.dynamic.base.DynamicSdk
import com.jd.dynamic.base.interfaces.IExceptionHandler
import com.jd.dynamic.lib.common.Constants
import com.jd.dynamic.lib.storage.IDYStorageCleaner
import com.jd.dynamic.lib.storage.IDYStorageFilterFile
import com.jd.dynamic.lib.utils.LogUtil
import java.io.File

/**
 * 清理非当前版本的兜底文件
 */
class DYBackupFileCleaner(private val fileFilter: IDYStorageFilterFile): IDYStorageCleaner {
    /**
     * path 是兜底文件存放根目录
     */
    override fun clean(path: String) {
        val file = File(path)
        if(file.exists() && file.isDirectory){
            val fileList = file.listFiles()?:return
            fileList.forEach {
                if(fileFilter.filter(it)){
                    deleteFile(it)
                }

            }
        }

    }
    private fun deleteFile(file:File){
            val files = file.listFiles()?:return
            files.forEach {
                if(it.isDirectory){
                    deleteFile(it)
                }else{
                    it.delete()
                    DynamicSdk.handException(IExceptionHandler.DynamicExceptionData.TYPE_FILE,
                            "DYBackupFileCleaner deleteFile ${it.absolutePath}",
                            null,null,Constants.HTTPResCode.CODE_DEL_BACKUP_FILE,null)
                }
            }
            file.delete()
            DynamicSdk.handException(IExceptionHandler.DynamicExceptionData.TYPE_FILE,
                "DYBackupFileCleaner deleteDir ${file.absolutePath}",
                null,null,Constants.HTTPResCode.CODE_DEL_BACKUP_FILE,null)

    }
}