package com.jd.dynamic.lib.storage.filters

import android.text.TextUtils
import com.jd.dynamic.base.DynamicSdk
import com.jd.dynamic.lib.storage.IDYStorageFilterFile
import com.jd.dynamic.lib.utils.LogUtil
import java.io.File

/**
 * 兜底文件压缩包解压目录过滤，版本和当前版本不一致就需要清理
 */
class DYAppVersionFilter: IDYStorageFilterFile {
    val version: String = DynamicSdk.getEngine().context.packageManager.getPackageInfo(DynamicSdk.getEngine().context.packageName,0).versionName
    override fun filter(file: File): Boolean {
        LogUtil.e("DYAppVersionFilter","file is ${file.name},app version is $version,is equals ${TextUtils.equals(file.name,version)}")
        return file.isDirectory && !TextUtils.equals(file.name,version)
    }
}