package com.jd.dynamic.lib.storage.filters

import com.jd.dynamic.lib.storage.IDYStorageFilterFile
import java.io.File

/**
 * @author: xuepanjie1
 * @date:2022/4/11
 * @description: 时间戳过滤器，过滤出小于这个时间的文件
 */

class DYTimeSmallFilter(private val time: Long) : IDYStorageFilterFile {
    override fun filter(file: File): Boolean {
        if (file.lastModified() >= time) {
            return false
        }
        return true
    }
}