package com.jd.dynamic.lib.storage.filters

import com.jd.dynamic.lib.storage.IDYStorageFilterFile
import java.io.File

/**
 * @author: xuepanjie1
 * @date:2022/5/19
 * @description: 时间这个可以增加阈值，目前是比扫描的旧就会删除，现在为了保证非法文件的正确删除，完全可以使用阈值差值
 * 拦截住了就不删了，这里就是最后修改时间在阈值之内的才删除
 */

class DYTimeThresholdFilter(private val time: Long,private val threshold:Long) : IDYStorageFilterFile {
    override fun filter(file: File): Boolean {
        if (file.lastModified() + threshold >= time) {
            return false
        }
        return true
    }
}