package com.jd.dynamic.lib.utils

import androidx.collection.ArrayMap
import androidx.recyclerview.widget.RecyclerView.RecycledViewPool
import com.jd.dynamic.lib.common.Constants

/**
 * @author: xuepanjie1
 * @date:2022/9/28
 * @description:
 */

class RecyclerInnerCachePool {
    private val cacheDYPools = ArrayMap<Int, DYRecyclePool>()

    fun clearPool() {
        cacheDYPools.clear()
    }

    private fun getInnerDYPool(outType: Int) : DYRecyclePool {
        val cachePool = cacheDYPools[outType]
        if (null != cachePool) {
            return cachePool
        }
        val pool = DYRecyclePool()
        cacheDYPools[outType] = pool
        return pool
    }

    fun obtainDYRecyclePool(outType: Any?) : DYRecyclePool? {
        if (outType is Int) {
            return getInnerDYPool(outType)
        }
        return null
    }

    class DYRecyclePool {
        private val cacheTypes = ArrayList<Int>()
        private val pool = RecycledViewPool()

        private fun isCache(type: Int) : Boolean {
            for (i in cacheTypes) {
                if (type == i) {
                    return true
                }
            }

            cacheTypes.add(type)
            return false
        }

        fun getPool() : RecycledViewPool {
            return pool
        }

        fun updateCacheDefaultSize(type: Int) {
            if (isCache(type)) {
                return
            }

            pool.setMaxRecycledViews(type, Constants.DEFAULT_SHARE_POOL_SIZE)
        }
    }
}