package com.jd.dynamic.lib.viewparse.iviews.carouselView

import android.view.View
import android.view.ViewGroup
import android.widget.FrameLayout
import androidx.recyclerview.widget.RecyclerView
import androidx.recyclerview.widget.RecyclerView.Adapter
import androidx.recyclerview.widget.RecyclerView.LayoutParams
import com.jd.dynamic.DYConstants
import com.jd.dynamic.lib.views.ItemView
import com.jd.dynamic.yoga.android.YogaLayout

/**
 * @author: xuepanjie1
 * @date:2022/10/25
 * @description:
 */

class NormalPageAdapter2(private val carouselView: CarouselView, private val isCycle: Boolean) :
    Adapter<RecyclerView.ViewHolder>(), ICarouselView {
    private var view: View? = null

    override fun getCurrentView(): View? {
        return view
    }

    override fun onCreateViewHolder(p0: ViewGroup, p1: Int): RecyclerView.ViewHolder {
        val parent = FrameLayout(p0.context)
        val pLayoutParam = ViewGroup.LayoutParams(
            LayoutParams.MATCH_PARENT,
            ViewGroup.LayoutParams.MATCH_PARENT)
        parent.layoutParams = pLayoutParam
        val item: View = carouselView.getCarouselItemViewFromId(p1.toString() + "").parse()
        (item as? YogaLayout)?.layoutParams =
            LayoutParams((item as YogaLayout).yogaLayoutLayoutParams)
        parent.addView(item)
        return ItemViewHolder(parent)
    }

    override fun onBindViewHolder(viewHolder: RecyclerView.ViewHolder, position: Int) {
        val calcPos = position % carouselView.dataSourceLength
        val view1: ItemView? =
            carouselView.getCarouselItemViewFromId(carouselView.getItemTypeByPosition(calcPos))
        view1?.bindData(viewHolder.itemView, carouselView.getDataByPosition(calcPos))
    }

    override fun getItemViewType(position: Int): Int {
        val calcPos = position % carouselView.dataSourceLength
        return carouselView.getItemTypeByPosition(calcPos).toInt()
    }

    override fun getItemCount(): Int {
        return if (isCycle) {
            Int.MAX_VALUE
        } else {
            carouselView.dataSourceLength
        }
    }

    internal class ItemViewHolder(itemView: View) : RecyclerView.ViewHolder(itemView)
}